'
' Demonstration for using the Busin/Busout code replacement routines
'
    Include "Amicus18.inc"          ' Configure the compiler ot use a PIC18F25K20 at 64MHz. i.e. An Amicus18 board
    Include "Busin.inc"             ' Load the replacement code for the Busin, Busout etc commands.
'
' Interface to a 24LC256 serial eeprom
' And display on the serial terminal the results
'
    Dim bLoop As Byte               ' Loading/retrieving loop
    Dim sMyString As String * 10    ' String to hold response
'
' Write bytes to the I2C bus
'
    HRSOut "Writing\r"              ' Transmit our intention to the serial terminal

    BStart                          ' Send a Start condition
    BusOut %10100000                ' Target an eeprom with bus address 0, and send a Write command
    BusOut 0                        ' Send the High Byte of the address
    BusOut 0                        ' Send the Low Byte of the address
    For bLoop = "0" To "9"          ' Create a loop containing ASCII 0 to 9
        HRSOut bLoop                ' Display the value on the serial terminal
        BusOut bLoop                ' Write the value of bLoop to the eeprom
    Next                            ' Close the loop
    BStop                           ' Send a Stop condition
    DelayMS 5                       ' Wait for the data to be entered into eeprom matrix
'
' Receive bytes from the I2C bus
'
    Clear sMyString                 ' Clear the string before we start
    HRSOut "\r\rReading\r"          ' Transmit our intention to the serial terminal

    BStart                          ' Send a Start condition
    BusOut %10100000                ' Target an eeprom with bus address 0, and send a Write command
    BusOut 0                        ' Send the High Byte of the address
    BusOut 0                        ' Send the Low Byte of the address
    BReStart                        ' Send a Restart condition
    BusOut %10100001                ' Target an eeprom with bus address 0, and send a Read command
    For bLoop = 0 To 9              ' Create a loop
        sMyString[bLoop] = BusIn    ' Load the String with bytes received
        If bLoop = 9 Then           ' Are we at the last byte?
            BStop                   ' Yes. So send a Stop condition
        Else                        ' Otherwise...
        BusAck                      ' Send an Ack condition
        EndIf
    Next                            ' Close the loop
    HRSOut sMyString, 13            ' Display the received string on the serial terminal



